# -*- coding: utf-8 -*-
import globalPluginHandler
import api
import browseMode
class GlobalPlugin(globalPluginHandler.GlobalPlugin):
	scriptCategory='Mzoo helper'
	def __init__(self, *args, **kwargs):
		globalPluginHandler.GlobalPlugin.__init__(self, *args, **kwargs)
		self.menu_links_labels=[u'животные', u'постройки', u'уход', u'экскурсии', u'соревнования']
		self.menu_links_classes=['zm2 grad0 relative', 'd8 zmG relative']
		gestures={}
		[gestures.__setitem__('kb:alt+nvda+'+str(i+1), 'activate') for i in range(5)]
		gestures['kb:alt+nvda+6']='go_to_club'
		gestures['kb:alt+nvda+`']='go_to_main'
		gestures[u'kb:alt+nvda+ё']='go_to_main'
		gestures['kb:alt+nvda+q']='go_to_my_tasks'
		gestures['kb:alt+nvda+w']='go_to_club_tasks'
		gestures['kb:alt+nvda+e']='go_to_club_battles'
		self.bindGestures(gestures)
	def get_links(self):
		obj=api.getFocusObject()
		treeInterceptor=obj.treeInterceptor
		if not isinstance(treeInterceptor, browseMode.BrowseModeDocumentTreeInterceptor):
			return False
		url=treeInterceptor.rootNVDAObject.IAccessibleObject.accValue(obj.IAccessibleChildID)
		if not url.startswith('https://mzoo.mobi'):
			return None
		try:
			links=api.getNavigatorObject().treeInterceptor._iterNodesByType('link')
		except:
			return None
		return links
	def check_menu_item(self, item):
		if not 'location' in item.obj.basicText:
			return False
		if not item.obj.IA2Attributes.get('class') in self.menu_links_classes:
			return False
		return True
	def script_activate(self, gesture):
		item_index=int(gesture._get_identifiers()[0].split('+')[-1])-1
		links=self.get_links()
		if not links:
			return
		for l in links:
			if l.label.lower().startswith(self.menu_links_labels[item_index]) and self.check_menu_item(l):
				self.activate_link(l)
				return
	def activate_link(self, link):
		link.report()
		link.activate()
	def script_go_to_main(self, gesture):
		links=self.get_links()
		if not links:
			return
		for l in links:
			if l.label.lower().startswith(u'главная'):
				self.activate_link(l)
				return
	def script_go_to_club(self, gesture):
		'''Перейти к клубу'''
		links=self.get_links()
		if not links:
			return
		for l in links:
			if l.label.lower().startswith(u'клуб'):
				self.activate_link(l)
				return
	def script_go_to_club_tasks(self, gesture):
		'''Перейти к клубным заданиям'''
		links=self.get_links()
		if not links:
			return
		for l in links:
			if l.label.lower().startswith(u'задания') and l.obj.IA2Attributes.get('class')=='zm2 grad0 relative':
				self.activate_link(l)
				return
	def script_go_to_my_tasks(self, gesture):
		'''Перейти к заданиям'''
		links=self.get_links()
		if not links:
			return
		for l in links:
			if l.label.lower().startswith(u'задания') and l.obj.IA2Attributes.get('class')=='zmL rad8 grad bb relative':
				self.activate_link(l)
				return
	def script_go_to_club_battles(self, gesture):
		'''Перейти к клубным турнирам'''
		links=self.get_links()
		if not links:
			return
		for l in links:
			if l.label.lower().startswith(u'турнир'):
				self.activate_link(l)
				return
